searchNodes=[{"doc":"Provides a convenient interface to retrying behavior. All durations are specified in milliseconds. Examples use Retry import Stream retry with : exponential_backoff |&gt; randomize |&gt; cap ( 1_000 ) |&gt; expiry ( 10_000 ) do # interact with external service end retry with : linear_backoff ( 10 , 2 ) |&gt; cap ( 1_000 ) |&gt; take ( 10 ) do # interact with external service end retry with : cycle ( [ 500 ] ) |&gt; take ( 10 ) do # interact with external service end The first retry will exponentially increase the delay, fudging each delay up to 10%, until the delay reaches 1 second and then give up after 10 seconds. The second retry will linearly increase the retry by a factor of 2 from 10ms giving up after 10 attempts. The third example shows how we can produce a delay stream using standard Stream functionality. Any stream of integers may be used as the value of with: .","ref":"Retry.html","title":"Retry","type":"module"},{"doc":"Retry a block of code delaying between each attempt the duration specified by the next item in the with delay stream. If the block returns any of the atoms specified in atoms , a retry will be attempted. Other atoms or atom-result tuples will not be retried. If atoms is not specified, it defaults to [:error] . Similary, if the block raises any of the exceptions specified in rescue_only , a retry will be attempted. Other exceptions will not be retried. If rescue_only is not specified, it defaults to [RuntimeError] . The after block evaluates only when the do block returns a valid value before timeout. On the other hand, the else block evaluates only when the do block remains erroneous after timeout. Example use Retry retry with : exponential_backoff ( ) |&gt; cap ( 1_000 ) |&gt; expiry ( 1_000 ) , rescue_only : [ CustomError ] do # interact with external service after result -&gt; result else error -&gt; error end The after and else clauses are optional. By default, a successful value is just returned. If the timeout expires, the last erroneous value is returned or the last exception is re-raised. Essentially, this: retry with : ... do ... end Is equivalent to: retry with : ... do ... after result -&gt; result else e when is_exception ( e ) -&gt; raise e e -&gt; e end","ref":"Retry.html#retry/2","title":"Retry.retry/2","type":"macro"},{"doc":"Retry a block of code until halt is emitted delaying between each attempt the duration specified by the next item in the with delay stream. The return value for block is expected to be {:cont, result} , return {:halt, result} to end the retry early. An accumulator can also be specified which might be handy if subsequent retries are dependent on the previous ones. The initial value of the accumulator is given as a keyword argument acc: . When the :acc key is given, its value is used as the initial accumulator and the do block must be changed to use -&gt; clauses, where the left side of -&gt; receives the accumulated value of the previous iteration and the expression on the right side must return the :cont / :halt tuple with new accumulator value as the second element. Once :halt is returned from the block, or there are no more elements, the accumulated value is returned. Example retry_while with : linear_backoff ( 500 , 1 ) |&gt; take ( 5 ) do call_service |&gt; case do result = %{ &quot;errors&quot; =&gt; true } -&gt; { :cont , result } result -&gt; { :halt , result } end end Example with acc: retry_while acc : 0 , with : linear_backoff ( 500 , 1 ) |&gt; take ( 5 ) do acc -&gt; call_service |&gt; case do %{ &quot;errors&quot; =&gt; true } -&gt; { :cont , acc + 1 } result -&gt; { :halt , result } end end","ref":"Retry.html#retry_while/2","title":"Retry.retry_while/2","type":"macro"},{"doc":"Wait for a block of code to be truthy delaying between each attempt the duration specified by the next item in the delay stream. The after block evaluates only when the do block returns a truthy value. On the other hand, the else block evaluates only when the do block remains falsy after timeout.Both are optional. By default, a success value will be returned as {:ok, value} and an erroneous value will be returned as {:error, value} . Example wait linear_backoff ( 500 , 1 ) |&gt; take ( 5 ) do we_there_yet? after _ -&gt; { :ok , &quot;We have arrived!&quot; } else _ -&gt; { :error , &quot;We&#39;re still on our way :(&quot; } end","ref":"Retry.html#wait/2","title":"Retry.wait/2","type":"macro"},{"doc":"A @retry annotation that will retry the function according to the retry settings. Examples use Retry.Annotation @retry with : constant_backoff ( 100 ) |&gt; Stream . take ( 10 ) def some_func ( arg ) do # ... end","ref":"Retry.Annotation.html","title":"Retry.Annotation","type":"module"},{"doc":"","ref":"Retry.Annotation.html#before_compile/1","title":"Retry.Annotation.before_compile/1","type":"macro"},{"doc":"","ref":"Retry.Annotation.html#on_definition/6","title":"Retry.Annotation.on_definition/6","type":"function"},{"doc":"This module provide a set of helper functions that produce delay streams for use with retry .","ref":"Retry.DelayStreams.html","title":"Retry.DelayStreams","type":"module"},{"doc":"Returns a stream that is the same as delays except that the delays never exceed max . This allow capping the delay between attempts to some max value. Example retry with : exponential_backoff ( ) |&gt; cap ( 10_000 ) do # ... end Produces an exponentially increasing delay stream until the delay reaches 10 seconds at which point it stops increasing","ref":"Retry.DelayStreams.html#cap/2","title":"Retry.DelayStreams.cap/2","type":"function"},{"doc":"Returns a constant stream of delays. Example retry with : constant_backoff ( 50 ) do # ... end","ref":"Retry.DelayStreams.html#constant_backoff/1","title":"Retry.DelayStreams.constant_backoff/1","type":"function"},{"doc":"Returns a delay stream that is the same as delays except it limits the total life span of the stream to time_budget . This calculation takes the execution time of the block being retried into account. The execution of the code within the block will not be interrupted, so the total time of execution may run over the time_budget depending on how long a single try will take. Optionally, you can specify a minimum delay so the smallest value doesn't go below the threshold. Example retry with : exponential_backoff ( ) |&gt; expiry ( 1_000 ) do # ... end Produces a delay stream that ends after 1 second has elapsed since its creation.","ref":"Retry.DelayStreams.html#expiry/3","title":"Retry.DelayStreams.expiry/3","type":"function"},{"doc":"Returns a stream of delays that increase exponentially. Example retry with : exponential_backoff do # ... end","ref":"Retry.DelayStreams.html#exponential_backoff/2","title":"Retry.DelayStreams.exponential_backoff/2","type":"function"},{"doc":"Returns a stream in which each element of delays is randomly adjusted to a number between 1 and the original delay. Example retry with : exponential_backoff ( ) |&gt; jitter ( ) do # ... end","ref":"Retry.DelayStreams.html#jitter/1","title":"Retry.DelayStreams.jitter/1","type":"function"},{"doc":"Returns a stream of delays that increase linearly. Example retry with : linear_backoff ( 50 , 2 ) do # ... end","ref":"Retry.DelayStreams.html#linear_backoff/2","title":"Retry.DelayStreams.linear_backoff/2","type":"function"},{"doc":"Returns a stream in which each element of delays is randomly adjusted no more than proportion of the delay. Example retry with : exponential_backoff ( ) |&gt; randomize do # ... end Produces an exponentially increasing delay stream where each delay is randomly adjusted to be within 10 percent of the original value","ref":"Retry.DelayStreams.html#randomize/2","title":"Retry.DelayStreams.randomize/2","type":"function"},{"doc":"ElixirRetry Simple Elixir macros for linear retry, exponential backoff and wait with composable delays.","ref":"readme.html","title":"README","type":"extras"},{"doc":"Add retry to your list of dependencies in mix.exs : def deps do [ { :retry , &quot;~&gt; 0.18&quot; } ] end Ensure retry is started before your application: def application do [ applications : [ :retry ] ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Check out the API reference for the latest documentation.","ref":"readme.html#documentation","title":"README - Documentation","type":"extras"},{"doc":"Retrying The retry([with: _,] do: _, after: _, else: _) macro provides a way to retry a block of code on failure with a variety of delay and give up behaviors. By default, the execution of a block is considered a failure if it returns :error , {:error, _} or raises a runtime error. An optional list of atoms can be specified in :atoms if you need to retry anything other than :error or {:error, _} , e.g. retry([with: _, atoms: [:not_ok]], do: _, after: _, else: _) . Similarly, an optional list of exceptions can be specified in :rescue_only if you need to retry anything other than RuntimeError , e.g. retry([with: _, rescue_only: [CustomError]], do: _, after: _, else: _) . The after block evaluates only when the do block returns a valid value before timeout. On the other hand, the else block evaluates only when the do block remains erroneous after timeout. Both are optional. By default, the else clause will return the last erroneous value or re-raise the last exception. The default after clause will simply return the last successful value. Example -- constant backoff result = retry with : constant_backoff ( 100 ) |&gt; Stream . take ( 10 ) do ExternalApi . do_something # fails if other system is down after result -&gt; result else error -&gt; error end This example retries every 100 milliseconds and gives up after 10 attempts. Example -- linear backoff result = retry with : linear_backoff ( 10 , 2 ) |&gt; cap ( 1_000 ) |&gt; Stream . take ( 10 ) do ExternalApi . do_something # fails if other system is down after result -&gt; result else error -&gt; error end This example increases the delay linearly with each retry, starting with 10 milliseconds, caps the delay at 1 second and gives up after 10 attempts. Example -- exponential backoff result = retry with : exponential_backoff ( ) |&gt; randomize |&gt; expiry ( 10_000 ) , rescue_only : [ TimeoutError ] do ExternalApi . do_something # fails if other system is down after result -&gt; result else error -&gt; error end Example -- optional clauses result = retry with : constant_backoff ( 100 ) |&gt; Stream . take ( 10 ) do ExternalApi . do_something # fails if other system is down end This example is equivalent to: result = retry with : constant_backoff ( 100 ) |&gt; Stream . take ( 10 ) do ExternalApi . do_something # fails if other system is down after result -&gt; result else e when is_exception ( e ) -&gt; raise e e -&gt; e end Example -- retry annotation use Retry.Annotation @retry with : constant_backoff ( 100 ) |&gt; Stream . take ( 10 ) def some_func ( arg ) do ExternalApi . do_something # fails if other system is down end This example shows how you can annotate a function to retry every 100 milliseconds and gives up after 10 attempts. Delay streams The with: option of retry accepts any Stream that yields integers. These integers will be interpreted as the amount of time to delay before retrying a failed operation. When the stream is exhausted retry will give up, returning the last value of the block. Example result = retry with : Stream . cycle ( [ 500 ] ) do ExternalApi . do_something # fails if other system is down after result -&gt; result else error -&gt; error end This will retry failures forever, waiting 0.5 seconds between attempts. Retry.DelayStreams provides a set of fully composable helper functions for building useful delay behaviors such as the ones in previous examples. See the Retry.DelayStreams module docs for full details and addition behavior not covered here. For convenience these functions are imported by use Retry so you can, usually, use them without prefixing them with the module name. Waiting Similar to retry(with: _, do: _) , the wait(delay_stream, do: _, after: _, else: _) macro provides a way to wait for a block of code to be truthy with a variety of delay and give up behaviors. The execution of a block is considered a failure if it returns false or nil . wait constant_backoff ( 100 ) |&gt; expiry ( 1_000 ) do we_there_yet? after _ -&gt; { :ok , &quot;We have arrived!&quot; } else _ -&gt; { :error , &quot;We&#39;re still on our way :(&quot; } end This example retries every 100 milliseconds and expires after 1 second. The after block evaluates only when the do block returns a truthy value. On the other hand, the else block evaluates only when the do block remains falsy after timeout. Both are optional. By default, a success value will be returned as {:ok, value} and an erroneous value will be returned as {:error, value} . Pretty nifty for those pesky asynchronous tests and building more reliable systems in general!","ref":"readme.html#features","title":"README - Features","type":"extras"}]